package com.yaohun.enderdragonwars;

import com.yaohun.enderdragonwars.effect.types.*;
import com.yaohun.enderdragonwars.game.Game;
import com.yaohun.enderdragonwars.listener.GameListener;
import com.yaohun.enderdragonwars.listener.LiveListener;
import com.yaohun.enderdragonwars.listener.PlayerListener;
import com.yaohun.enderdragonwars.listener.RepairGiftGui;
import com.yaohun.enderdragonwars.manager.GameManager;
import com.yaohun.enderdragonwars.manager.GiftEffectManager;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;

public class Main extends JavaPlugin {

    public static Main plugin;
    public static GameManager gameManager;
    public static Game game;

    @Override
    public void onEnable() {
        plugin = this;
        GiftEffectManager.registerAll();
        gameManager = new GameManager();
        game = new Game();

        Bukkit.getPluginManager().registerEvents(new PlayerListener(), this);
        Bukkit.getPluginManager().registerEvents(new GameListener(), this);
        Bukkit.getPluginManager().registerEvents(new LiveListener(), this);
        Bukkit.getPluginManager().registerEvents(new RepairGiftGui(), this);
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String Command, String[] args) {
        if (args.length == 1 && args[0].equalsIgnoreCase("start")) {
            Player player = (Player) sender;
            game.startGame(player);
            return true;
        }
        if (args.length == 1) {
            String subCommand = args[0];
            Player player = (Player) sender;
            game.startGame(player);
            if (subCommand.equalsIgnoreCase("1")) {
                new BomBomEffect(player.getName()).apply(game);
            } else if (subCommand.equalsIgnoreCase("2")) {
                new ClearInventoryEffect(player.getName()).apply(game);
            } else if (subCommand.equalsIgnoreCase("3")) {
                new FiveLightningEffect(player.getName()).apply(game);
            } else if (subCommand.equalsIgnoreCase("4")) {
                new BlackHoleEffect(player.getName()).apply(game);
            } else if (subCommand.equalsIgnoreCase("5")) {
                new LavaPoolEffect(player.getName()).apply(game);
            } else if (subCommand.equalsIgnoreCase("6")) {
                new AddMaxHealthEffect(player.getName()).apply(game);
            } else if (subCommand.equalsIgnoreCase("7")) {
                new TakeMaxHealthEffect(player.getName()).apply(game);
            } else if (subCommand.equalsIgnoreCase("8")) {
                new SpawnEnderPortalEffect(player.getName()).apply(game);
            } else if (subCommand.equalsIgnoreCase("9")) {
                new PlayerBigEffect(player.getName()).apply(game);
            } else if (subCommand.equalsIgnoreCase("10")) {
                new PlayerSmallEffect(player.getName()).apply(game);
            } else if (subCommand.equalsIgnoreCase("11")) {
                new PlayerResetEffect(player.getName()).apply(game);
            } else if (subCommand.equalsIgnoreCase("12")) {
                new SpawnBuildEffect(player.getName()).apply(game);
            } else if (subCommand.equalsIgnoreCase("13")) {
                new ToHeavenEffect(player.getName()).apply(game);
            } else if (subCommand.equalsIgnoreCase("14")) {
                new LuckyBlockEffect(player.getName()).apply(game);
            }
        }
        return true;
    }

    @Override
    public void onDisable() {
        GiftEffectManager.stopQueue();
    }

}
