package com.yaohun.enderdragonwars.effect.types;

import com.yaohun.enderdragonwars.Main;
import com.yaohun.enderdragonwars.effect.GiftEffect;
import com.yaohun.enderdragonwars.game.Game;
import org.bukkit.Particle;
import org.bukkit.attribute.Attribute;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;

import java.util.UUID;

public class AddMaxHealthEffect extends GiftEffect {

    public static UUID uuid = UUID.randomUUID();

    public AddMaxHealthEffect(String audience) {
        super(audience);
    }

    @Override
    public void apply(Game game) {
        Player player = game.getPlayer();
        new BukkitRunnable() {
            private int count = 0;

            @Override
            public void run() {
                if (count >= 50) {
                    cancel();
                    return;
                }
                player.spawnParticle(Particle.HEART, player.getLocation().add(0, 0.5, 0), 1, 0.25, 0.25, 0.25, 0.1);
                if (player.getAttribute(Attribute.GENERIC_MAX_HEALTH).getValue() < 120) {
                    player.getAttribute(Attribute.GENERIC_MAX_HEALTH).setBaseValue(player.getAttribute(Attribute.GENERIC_MAX_HEALTH).getBaseValue() + 2);
                    player.setHealth(Math.min(player.getHealth() + 2, player.getMaxHealth()));
                }
                count++;
            }
        }.runTaskTimer(Main.plugin, 0L, 1L);
    }

    @Override
    public int getQueueTime() {
        return 55;
    }

}
