package com.yaohun.enderdragonwars.effect.types;

import com.yaohun.enderdragonwars.Main;
import com.yaohun.enderdragonwars.effect.GiftEffect;
import com.yaohun.enderdragonwars.game.Game;
import com.yaohun.enderdragonwars.util.EntityUtil;
import net.kyori.adventure.text.Component;
import org.bukkit.*;
import org.bukkit.attribute.Attribute;
import org.bukkit.boss.BarColor;
import org.bukkit.boss.BarStyle;
import org.bukkit.boss.BossBar;
import org.bukkit.entity.*;
import org.bukkit.event.entity.CreatureSpawnEvent;
import org.bukkit.inventory.EquipmentSlot;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ColorableArmorMeta;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.scheduler.BukkitRunnable;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Random;

public class BomBomEffect extends GiftEffect {

    private static final ItemStack ITEM_1;
    private static final ItemStack ITEM_2;
    private static final ItemStack ITEM_3;
    private static final ItemStack ITEM_4;

    private static final ItemStack ITEM_5;
    private static final ItemStack ITEM_6;
    private static final ItemStack ITEM_7;

    static {
        ITEM_1 = new ItemStack(Material.TNT);
        ITEM_2 = new ItemStack(Material.LEATHER_CHESTPLATE);
        ITEM_3 = new ItemStack(Material.LEATHER_LEGGINGS);
        ITEM_4 = new ItemStack(Material.LEATHER_BOOTS);
        ITEM_5 = new ItemStack(Material.LEATHER_CHESTPLATE);
        ITEM_6 = new ItemStack(Material.LEATHER_LEGGINGS);
        ITEM_7 = new ItemStack(Material.LEATHER_BOOTS);
        Color color1 = Color.fromRGB(214, 41, 0);
        Color color2 = Color.fromRGB(255, 133, 102);
        ItemMeta itemMeta2 = ITEM_2.getItemMeta();
        ColorableArmorMeta colorableArmorMeta2 = (ColorableArmorMeta) itemMeta2;
        colorableArmorMeta2.setColor(color1);
        ITEM_2.setItemMeta(colorableArmorMeta2);
        ItemMeta itemMeta3 = ITEM_3.getItemMeta();
        ColorableArmorMeta colorableArmorMeta3 = (ColorableArmorMeta) itemMeta3;
        colorableArmorMeta3.setColor(color1);
        ITEM_3.setItemMeta(colorableArmorMeta3);
        ItemMeta itemMeta4 = ITEM_4.getItemMeta();
        ColorableArmorMeta colorableArmorMeta4 = (ColorableArmorMeta) itemMeta4;
        colorableArmorMeta4.setColor(color1);
        ITEM_4.setItemMeta(colorableArmorMeta4);
        ItemMeta itemMeta5 = ITEM_5.getItemMeta();
        ColorableArmorMeta colorableArmorMeta5 = (ColorableArmorMeta) itemMeta5;
        colorableArmorMeta5.setColor(color2);
        ITEM_5.setItemMeta(colorableArmorMeta5);
        ItemMeta itemMeta6 = ITEM_6.getItemMeta();
        ColorableArmorMeta colorableArmorMeta6 = (ColorableArmorMeta) itemMeta6;
        colorableArmorMeta6.setColor(color2);
        ITEM_6.setItemMeta(colorableArmorMeta6);
        ItemMeta itemMeta7 = ITEM_7.getItemMeta();
        ColorableArmorMeta colorableArmorMeta7 = (ColorableArmorMeta) itemMeta7;
        colorableArmorMeta7.setColor(color2);
        ITEM_7.setItemMeta(colorableArmorMeta7);

    }

    protected boolean stop = false;
    private List<FallingBlock> fallingBlocks = new ArrayList<>();
    private BossBar bossBar;

    public BomBomEffect(String audience) {
        super(audience);
    }

    @Override
    public void apply(Game game) {
        bossBar = Bukkit.createBossBar("§4§l毁天灭地", BarColor.RED, BarStyle.SOLID);
        World world = game.getWorld();
        Player player = game.getPlayer();
        bossBar.addPlayer(player);
        ArmorStand armorStand = (ArmorStand) world.spawnEntity(player.getLocation(), EntityType.ARMOR_STAND, CreatureSpawnEvent.SpawnReason.CUSTOM, (entity) -> {
            ArmorStand armorStand1 = (ArmorStand) entity;
            armorStand1.setArms(true);
            armorStand1.setBasePlate(false);
            armorStand1.customName(Component.text("§4§l毁天灭地"));
            armorStand1.setCustomNameVisible(true);
            armorStand1.setDisabledSlots(EquipmentSlot.values());
            armorStand1.setInvulnerable(true);
            armorStand1.setGravity(false);
            armorStand1.getEquipment().setItemInMainHand(ITEM_1);
            armorStand1.getEquipment().setItemInOffHand(ITEM_1);
            armorStand1.getEquipment().setItem(EquipmentSlot.HEAD, ITEM_1);
            armorStand1.getEquipment().setItem(EquipmentSlot.CHEST, ITEM_2);
            armorStand1.getEquipment().setItem(EquipmentSlot.LEGS, ITEM_3);
            armorStand1.getEquipment().setItem(EquipmentSlot.FEET, ITEM_4);
            armorStand1.getAttribute(Attribute.GENERIC_SCALE).setBaseValue(6.0);
        });
        new BukkitRunnable() {
            private int count = 0;

            @Override
            public void run() {
                Location loc = armorStand.getLocation().clone().add(0, 8, 0);
                if (count > 30) {
                    armorStand.remove();
                    for (int i = 0; i < 3; i++) {
                        armorStand.getWorld().createExplosion(armorStand.getLocation(), 5f, true, true);
                    }
                    Random random = new Random();
                    for (int i = 0; i < 500; i++) {
                        FallingBlock fallingBlock = (FallingBlock) world.spawnEntity(loc, EntityType.FALLING_BLOCK, CreatureSpawnEvent.SpawnReason.CUSTOM, (fallingBlockEntity) -> {
                            FallingBlock fallingBlock1 = (FallingBlock) fallingBlockEntity;
                            fallingBlock1.setBlockData(Bukkit.createBlockData(Material.MAGMA_BLOCK));
                            fallingBlock1.setDropItem(false);
                            fallingBlock1.setCancelDrop(true);
                        });
                        fallingBlocks.add(fallingBlock);
                        EntityUtil.shoot(fallingBlock, (Math.random() * 1.8D - 1.5D) * 0.1f, 0.2f + Math.random() * 0.1f, (Math.random() * 1.8D - 1.5D) * 0.1f, 3f + random.nextFloat() * 1.5f, 0f);
                        player.getWorld().playSound(fallingBlock.getLocation(), Sound.ENTITY_GENERIC_EXPLODE, 1f, 1f);
                    }
                    bossBar.removeAll();
                    stop = true;
                    cancel();
                    return;
                }
                Random random = new Random();
                for (int i = 0; i < 35; i++) {
                    FallingBlock fallingBlock = (FallingBlock) world.spawnEntity(loc, EntityType.FALLING_BLOCK, CreatureSpawnEvent.SpawnReason.CUSTOM, (fallingBlockEntity) -> {
                        FallingBlock fallingBlock1 = (FallingBlock) fallingBlockEntity;
                        fallingBlock1.setBlockData(Bukkit.createBlockData(Material.MAGMA_BLOCK));
                        fallingBlock1.setDropItem(false);
                        fallingBlock1.setCancelDrop(true);
                        fallingBlock1.setFireTicks(200);
                    });
                    fallingBlocks.add(fallingBlock);
                    EntityUtil.shoot(fallingBlock, (Math.random() * 2.5D - 1.5D) * 0.1f, 0.4f + Math.random() * 0.15f, (Math.random() * 2.5D - 1.5D) * 0.1f, 3f + random.nextFloat() * 1.5f, 0f);
                    player.getWorld().playSound(fallingBlock.getLocation(), Sound.ENTITY_GENERIC_EXPLODE, 1f, 1f);
                }
                for (int i = 0; i < 15; i++) {
                    TNTPrimed tntPrimed = (TNTPrimed) world.spawnEntity(loc, EntityType.TNT, CreatureSpawnEvent.SpawnReason.CUSTOM, (tntEntity) -> {
                        TNTPrimed tntPrimed1 = (TNTPrimed) tntEntity;
                        tntPrimed1.setFuseTicks(80);
                        tntPrimed1.setYield(4);
                    });
                    EntityUtil.shoot(tntPrimed, (Math.random() * 2D - 1.5D) * 0.08f, 0.1f + Math.random() * 0.025f, (Math.random() * 2D - 1.5D) * 0.08f, 3f + random.nextFloat() * 1.5f, 0f);
                }
                count++;
            }
        }.runTaskTimer(Main.plugin, 0L, 15L);
        new BukkitRunnable() {
            private int count = 0;

            @Override
            public void run() {
                if (stop) {
                    cancel();
                    return;
                }
                boolean flag = count % 2 == 0;
                armorStand.customName(Component.text(flag ? "§4§l毁天灭地" : "§c§l毁天灭地"));
                armorStand.getEquipment().setItem(EquipmentSlot.CHEST, flag ? ITEM_2 : ITEM_5);
                armorStand.getEquipment().setItem(EquipmentSlot.LEGS, flag ? ITEM_3 : ITEM_6);
                armorStand.getEquipment().setItem(EquipmentSlot.FEET, flag ? ITEM_4 : ITEM_7);
                bossBar.setTitle(flag ? "§4§l毁天灭地" : "§c§l毁天灭地");
                count++;
            }
        }.runTaskTimer(Main.plugin, 0L, 5L);
        new BukkitRunnable() {
            private int count = 0;

            @Override
            public void run() {
                if (stop) {
                    cancel();
                    return;
                }
                float f = count * 25F;
                armorStand.setRotation(f, 0);
                Location location1 = armorStand.getLocation().clone().add(0, 0.35, 0);
                armorStand.getWorld().spawnParticle(Particle.LAVA, location1, 5, 0.2, 0.6, 0.2, 0.05);
                armorStand.getWorld().spawnParticle(Particle.FLAME, location1, 5, 0.2, 1, 0.2, 0.01);
                count++;
            }
        }.runTaskTimer(Main.plugin, 0L, 2L);
        new BukkitRunnable() {
            @Override
            public void run() {
                if (fallingBlocks.isEmpty()) {
                    cancel();
                    return;
                }
                Iterator<FallingBlock> iterator = fallingBlocks.iterator();
                while (iterator.hasNext()) {
                    FallingBlock fallingBlock = iterator.next();
                    Location location = fallingBlock.getLocation();
                    if (fallingBlock.isOnGround() || fallingBlock.isDead()) {
                        location.getWorld().createExplosion(location, 5f, true, true);
                        armorStand.getWorld().spawnParticle(Particle.LAVA, fallingBlock.getLocation(), 35, 1.5, 1.5, 1.5, 0.05);
                        armorStand.getWorld().spawnParticle(Particle.FLAME, fallingBlock.getLocation(), 35, 1.5, 1.5, 1.5, 0.01);
                        location.add(0, 1, 0).getBlock().setType(Material.LAVA);
                        fallingBlock.remove();
                        iterator.remove();
                        return;
                    }
                }
            }
        }.runTaskTimer(Main.plugin, 0L, 1L);
    }

}
