package com.yaohun.enderdragonwars.effect.types;

import com.yaohun.enderdragonwars.effect.GiftEffect;
import com.yaohun.enderdragonwars.game.Game;
import com.yaohun.enderdragonwars.util.RandomUtil;
import net.kyori.adventure.text.Component;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.entity.Blaze;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.MagmaCube;
import org.bukkit.entity.Player;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;

public class LavaPoolEffect extends GiftEffect {

    public LavaPoolEffect(String audience) {
        super(audience);
    }

    @Override
    public void apply(Game game) {
        Player player = game.getPlayer();
        Location location = player.getLocation();

        int size = 20;

        int minX = location.getBlockX() - size / 2;
        int minY = location.getBlockY() - 3;
        int minZ = location.getBlockZ() - size / 2;
        int maxX = location.getBlockX() + size / 2;
        int maxY = location.getBlockY();
        int maxZ = location.getBlockZ() + size / 2;

        for (int i = 0; i < 6; i++) {
            Location location1 = getRandomLocation(location.add(0, 3, 0), size - 3, 3, size - 3);
            Blaze blaze = (Blaze) location1.getWorld().spawnEntity(location1, EntityType.BLAZE);
            blaze.setTarget(player);
            blaze.customName(Component.text("§4§l烈焰人"));
            blaze.setCustomNameVisible(true);
        }
        for (int i = 0; i < 6; i++) {
            Location location1 = getRandomLocation(location, size - 3, 0, size - 3);
            MagmaCube magmaCube = (MagmaCube) location1.getWorld().spawnEntity(location1, EntityType.MAGMA_CUBE);
            magmaCube.setTarget(player);
            magmaCube.customName(Component.text("§4§l岩浆怪"));
            magmaCube.setCustomNameVisible(true);
        }
        player.addPotionEffect(new PotionEffect(PotionEffectType.FIRE_RESISTANCE, 20 * 60, 1, true, true, true));

        for (int x = minX; x <= maxX; x++) {
            for (int y = minY; y <= maxY; y++) {
                for (int z = minZ; z <= maxZ; z++) {
                    Block block = location.getWorld().getBlockAt(x, y, z);
                    block.setType(Material.LAVA);
                }
            }
        }

    }

    private Location getRandomLocation(Location location, double xRange, double yRange, double zRange) {
        return new Location(location.getWorld(),
                RandomUtil.getRandomDouble(location.getX() - xRange, location.getX() + xRange, 1),
                RandomUtil.getRandomDouble(location.getY() - yRange, location.getY() + yRange, 1),
                RandomUtil.getRandomDouble(location.getZ() - zRange, location.getZ() + zRange, 1));
    }

}
