package com.yaohun.enderdragonwars.effect.types;

import com.yaohun.enderdragonwars.effect.GiftEffect;
import com.yaohun.enderdragonwars.game.Game;
import com.yaohun.enderdragonwars.util.ItemStackBuilder;
import com.yaohun.enderdragonwars.util.RandomUtil;
import org.bukkit.*;
import org.bukkit.block.Block;
import org.bukkit.enchantments.Enchantment;
import org.bukkit.entity.Item;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;

import java.util.ArrayList;
import java.util.List;

public class LuckyBlockEffect extends GiftEffect {

    private static List<ItemStack> itemStacks = new ArrayList<>();

    static {
        itemStacks.add(new ItemStackBuilder(Material.ENDER_PEARL).setAmount(16).build());
        itemStacks.add(new ItemStackBuilder(Material.ENDER_EYE).setAmount(16).build());
        itemStacks.add(new ItemStackBuilder(Material.DIAMOND_BLOCK).setAmount(16).build());
        itemStacks.add(new ItemStackBuilder(Material.DIAMOND).setAmount(64).build());

        itemStacks.add(new ItemStackBuilder(Material.GOLDEN_APPLE).setAmount(16).build());
        itemStacks.add(new ItemStackBuilder(Material.ENCHANTED_GOLDEN_APPLE).setAmount(4).build());

        itemStacks.add(new ItemStackBuilder(Material.CARROT).setAmount(64).build());
        itemStacks.add(new ItemStackBuilder(Material.GOLDEN_CARROT).setAmount(64).build());
        itemStacks.add(new ItemStackBuilder(Material.BAKED_POTATO).setAmount(64).build());
        itemStacks.add(new ItemStackBuilder(Material.COOKED_BEEF).setAmount(64).build());
        itemStacks.add(new ItemStackBuilder(Material.COOKED_CHICKEN).setAmount(64).build());
        itemStacks.add(new ItemStackBuilder(Material.COOKED_COD).setAmount(64).build());
        itemStacks.add(new ItemStackBuilder(Material.COOKED_MUTTON).setAmount(64).build());
        itemStacks.add(new ItemStackBuilder(Material.COOKED_SALMON).setAmount(64).build());
        itemStacks.add(new ItemStackBuilder(Material.COOKED_PORKCHOP).setAmount(64).build());

        Tag.LOGS.getValues().forEach(material -> itemStacks.add(new ItemStackBuilder(material).setAmount(64).build()));

        Tag.ITEMS_AXES.getValues().forEach(material -> itemStacks.add(new ItemStackBuilder(material).build()));
        Tag.ITEMS_PICKAXES.getValues().forEach(material -> itemStacks.add(new ItemStackBuilder(material).build()));
        Tag.ITEMS_SHOVELS.getValues().forEach(material -> itemStacks.add(new ItemStackBuilder(material).build()));

        itemStacks.add(new ItemStackBuilder(Material.DIAMOND_HELMET).build());
        itemStacks.add(new ItemStackBuilder(Material.DIAMOND_CHESTPLATE).build());
        itemStacks.add(new ItemStackBuilder(Material.DIAMOND_LEGGINGS).build());
        itemStacks.add(new ItemStackBuilder(Material.DIAMOND_BOOTS).build());
        itemStacks.add(new ItemStackBuilder(Material.DIAMOND_SWORD).build());
        itemStacks.add(new ItemStackBuilder(Material.DIAMOND_HELMET).addEnchant(Enchantment.PROTECTION, 1).build());
        itemStacks.add(new ItemStackBuilder(Material.DIAMOND_CHESTPLATE).addEnchant(Enchantment.PROTECTION, 1).build());
        itemStacks.add(new ItemStackBuilder(Material.DIAMOND_LEGGINGS).addEnchant(Enchantment.PROTECTION, 1).build());
        itemStacks.add(new ItemStackBuilder(Material.DIAMOND_BOOTS).addEnchant(Enchantment.PROTECTION, 1).build());
        itemStacks.add(new ItemStackBuilder(Material.DIAMOND_SWORD).addEnchant(Enchantment.SHARPNESS, 1).build());
        itemStacks.add(new ItemStackBuilder(Material.NETHERITE_HELMET).build());
        itemStacks.add(new ItemStackBuilder(Material.NETHERITE_CHESTPLATE).build());
        itemStacks.add(new ItemStackBuilder(Material.NETHERITE_LEGGINGS).build());
        itemStacks.add(new ItemStackBuilder(Material.NETHERITE_BOOTS).build());
        itemStacks.add(new ItemStackBuilder(Material.NETHERITE_SWORD).build());
        itemStacks.add(new ItemStackBuilder(Material.NETHERITE_HELMET).addEnchant(Enchantment.PROTECTION, 1).build());
        itemStacks.add(new ItemStackBuilder(Material.NETHERITE_CHESTPLATE).addEnchant(Enchantment.PROTECTION, 1).build());
        itemStacks.add(new ItemStackBuilder(Material.NETHERITE_LEGGINGS).addEnchant(Enchantment.PROTECTION, 1).build());
        itemStacks.add(new ItemStackBuilder(Material.NETHERITE_BOOTS).addEnchant(Enchantment.PROTECTION, 1).build());
        itemStacks.add(new ItemStackBuilder(Material.NETHERITE_SWORD).addEnchant(Enchantment.SHARPNESS, 1).build());

    }

    public LuckyBlockEffect(String audience) {
        super(audience);
    }

    public static void openLuckyBlock(Player player, Block block) {
        Location location = block.getLocation().add(0.5, 0.5, 0.5);
        location.getWorld().spawnParticle(Particle.FIREWORK, location, 35, 0.55, 0.55, 0.55, 0.05);
        player.playSound(player.getLocation(), Sound.ENTITY_PLAYER_LEVELUP, 1, 1);
        ItemStack itemStack = itemStacks.get(RandomUtil.getRandomInt(0, itemStacks.size() - 1));
        Item item = location.getWorld().dropItemNaturally(location, itemStack);
        item.setOwner(player.getUniqueId());
        if (itemStack.getItemMeta().hasDisplayName()) {
            item.customName(itemStack.getItemMeta().displayName());
            item.setCustomNameVisible(true);
        }
        item.setGlowing(true);
    }

    @Override
    public void apply(Game game) {
        game.getPlayer().getInventory().addItem(new ItemStackBuilder(Material.SPONGE).setDisplayName("§6§l幸运方块").build());
    }

}
