package com.yaohun.enderdragonwars.effect.types;

import com.yaohun.enderdragonwars.Main;
import com.yaohun.enderdragonwars.data.Region;
import com.yaohun.enderdragonwars.effect.GiftEffect;
import com.yaohun.enderdragonwars.game.Game;
import com.yaohun.enderdragonwars.util.BuildSpawner;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.entity.Player;

import java.util.Arrays;
import java.util.List;

public class SpawnEnderPortalEffect extends GiftEffect {

    private static final List<Material> MATERIAL_LIST = Arrays.asList(Material.WHITE_WOOL, Material.BLACK_WOOL, Material.BROWN_WOOL, Material.BLUE_WOOL, Material.GREEN_WOOL, Material.RED_WOOL, Material.YELLOW_WOOL, Material.PURPLE_WOOL, Material.ORANGE_WOOL, Material.PINK_WOOL, Material.LIGHT_BLUE_WOOL, Material.LIME_WOOL);


    public SpawnEnderPortalEffect(String audience) {
        super(audience);
    }

    @Override
    public void apply(Game game) {
        int chunkWight = 2;
        int chunkLength = 2;
        int ladderLength = 3;
        int ladderAmount = 5;
        int platformWidth = 3;
        int platformLength = 7;
        int levelAmount = 15;
        Main.game.takeLiveTime(60 * 6);
        World world = game.getWorld();
        Player player = game.getPlayer();
        Location location = player.getLocation();
        BuildSpawner buildSpawner = new BuildSpawner(world, BuildSpawner.Direction.NORTH, location.getBlockX(), location.getBlockY() - 1, location.getBlockZ(), chunkWight, chunkLength, ladderLength, ladderAmount, platformWidth, platformLength, levelAmount, BuildSpawner.SpawnMode.MODE_2, MATERIAL_LIST);
        Region region = buildSpawner.getEffectiveRegion(world);
        for (int x = region.getMin().getBlockX(); x <= region.getMax().getBlockX(); x++) {
            for (int y = region.getMin().getBlockY(); y <= region.getMax().getBlockY(); y++) {
                for (int z = region.getMin().getBlockZ(); z <= region.getMax().getBlockZ(); z++) {
                    if (world.getBlockAt(x, y, z).getType() != Material.AIR) {
                        world.getBlockAt(x, y, z).setType(Material.AIR);
                    }
                }
            }
        }
        buildSpawner.spawn();
    }

}
