package com.yaohun.enderdragonwars.effect.types;

import com.yaohun.enderdragonwars.Main;
import com.yaohun.enderdragonwars.effect.GiftEffect;
import com.yaohun.enderdragonwars.game.Game;
import org.bukkit.Effect;
import org.bukkit.Location;
import org.bukkit.Sound;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Player;
import org.bukkit.entity.TNTPrimed;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.scheduler.BukkitTask;

public class WuHuJump extends GiftEffect {

    public WuHuJump(String audience) {
        super(audience);
    }

    @Override
    public void apply(Game game) {
        Player player = game.getPlayer();
        player.setVelocity(player.getLocation().getDirection().multiply(0.5).setY(1.0));
        player.playEffect(player.getLocation(), Effect.MOBSPAWNER_FLAMES, 10);
        player.playSound(player.getLocation(), Sound.ENTITY_BAT_TAKEOFF, 1.0F, 1.0F);
        BukkitTask task = new BukkitRunnable() {
            private int i = 0;

            @Override
            public void run() {
                if (i >= 4) {
                    cancel();
                }
                Location location = player.getLocation();
                TNTPrimed tntPrimed = (TNTPrimed) location.getWorld().spawnEntity(location.clone().add(0, -0.5, 0), EntityType.TNT);
                tntPrimed.setFuseTicks(5);
                tntPrimed.setYield(0.0F);
                location.getWorld().playSound(location, Sound.ENTITY_CREEPER_PRIMED, 1.0f, 1.0f);
                i++;
            }
        }.runTaskTimer(Main.plugin, 2L, 1L);
        game.addTasks(task);
    }

}
