package com.yaohun.enderdragonwars.listener;

import com.yaohun.enderdragonwars.effect.types.LuckyBlockEffect;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.entity.Entity;
import org.bukkit.entity.IronGolem;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.event.player.PlayerInteractEntityEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.PlayerInventory;

import java.util.HashMap;
import java.util.Map;

public class PlayerListener implements Listener {

    private static Map<Player, ItemStack> totem = new HashMap<>();

    @EventHandler
    public void onEntityDamage(EntityDamageEvent event) {
        if (event.getEntity() instanceof Player player) {
            PlayerInventory inventory = player.getInventory();
            Material item = Material.TOTEM_OF_UNDYING;
            ItemStack mainhand = inventory.getItemInMainHand();
            ItemStack offhand = inventory.getItemInOffHand();
            if (player.getHealth() - event.getFinalDamage() <= 0.0d && inventory.contains(item)) {
                if (mainhand != null && mainhand.getType() == item) {
                    return;
                }
                if ((offhand == null || offhand.getType() != item)) {
                    this.totem.put(player, inventory.getItemInOffHand());
                    ItemStack[] contents = inventory.getContents();
                    int length = contents.length;
                    int i = 0;
                    while (true) {
                        if (i >= length) {
                            break;
                        }
                        ItemStack totem = contents[i];
                        if (totem != null && totem.getType().equals(item)) {
                            totem.setAmount(totem.getAmount() - 1);
                            break;
                        }
                        i++;
                    }
                    inventory.setItemInOffHand(new ItemStack(Material.TOTEM_OF_UNDYING));
                }
            }
        }
    }

    @EventHandler
    public void onPlayerBreakBlock(BlockBreakEvent event) {
        Player player = event.getPlayer();
        Block block = event.getBlock();
        if (block.getType() == Material.SPONGE) {
            event.setCancelled(true);
            block.setType(Material.AIR);
            LuckyBlockEffect.openLuckyBlock(player, block);
        }
    }

    @EventHandler
    public void onPlayerInteractEntity(PlayerInteractEntityEvent event) {
        Player player = event.getPlayer();
        Entity entity = event.getRightClicked();
        if (entity instanceof IronGolem) {
            entity.addPassenger(player);
        }
    }


}
