package com.yaohun.enderdragonwars.manager;

import com.yaohun.enderdragonwars.data.GiftData;
import org.bukkit.Bukkit;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.util.HashMap;
import java.util.Map;

public class GameManager {

    private int dianzan = 0;
    private int dianzanNeed;
    private String eventName;
    private Map<String, GiftData> giftDataMap = new HashMap<>();

    public GameManager() {
        loadGiftData();
    }

    public void loadGiftData() {
        File file = new File("./plugins/游戏设置", "礼物设置.yml");
        FileConfiguration yml = YamlConfiguration.loadConfiguration(file);
        Bukkit.getConsoleSender().sendMessage("[日志 - 末影龙挑战] 事件注册:");
        this.dianzanNeed = 100;
        if (yml.getInt("点赞整蛊.点赞次数") >= 1) {
            this.dianzanNeed = yml.getInt("点赞整蛊.点赞次数");
        }
        this.eventName = "怪物来袭";
        if (yml.getString("点赞整蛊.效果") != null) {
            this.eventName = yml.getString("点赞整蛊.效果");
        }
        Bukkit.getConsoleSender().sendMessage("事件: " + this.getDianzan_event() + "  条件: 点赞x" + this.getDianzan_need());
        ConfigurationSection section = yml.getConfigurationSection("礼物设置");
        if (section == null) {
            System.out.println("[错误 - 游戏] 礼物设置错误,请检查文件.");
            return;
        }
        for (String giftName : section.getKeys(false)) {
            giftDataMap.put(giftName, new GiftData(giftName, yml));
        }
    }

    public Map<String, GiftData> getGiftDataMap() {
        return giftDataMap;
    }

    public GiftData getGiftData(String giftName) {
        if (getGiftDataMap().get(giftName) == null) {
            return null;
        }
        return getGiftDataMap().get(giftName);
    }

    public int getDianzan_need() {
        return this.dianzanNeed;
    }

    public String getDianzan_event() {
        return this.eventName;
    }

    public int getDianzan_amount() {
        return dianzan;
    }

    public void setDianzan_amount(int dianzan_amount) {
        this.dianzan = dianzan_amount;
    }

    public void addDianzan_amount(int add_amount) {
        setDianzan_amount(getDianzan_amount() + add_amount);
    }
}
