package com.yaohun.enderdragonwars.util;

import org.bukkit.boss.BarColor;
import org.bukkit.boss.BossBar;
import org.bukkit.entity.Player;

import java.util.List;

public class BossBarUtil {

    public static void setBarColor(BossBar bossBar) {
        double random = RandomUtil.getRandomDouble(0, 1, 1);
        if (random >= 0 && random <= 0.2) {
            bossBar.setColor(BarColor.RED);
        } else if (random <= 0.4) {
            bossBar.setColor(BarColor.YELLOW);
        } else if (random <= 0.6) {
            bossBar.setColor(BarColor.GREEN);
        } else if (random <= 0.8) {
            bossBar.setColor(BarColor.BLUE);
        } else {
            bossBar.setColor(BarColor.PURPLE);
        }
    }

    public static void setBarColor(BossBar bossBar, double percent) {
        if (percent >= 0 && percent <= 0.3333) {
            bossBar.setColor(BarColor.RED);
        } else if (percent <= 0.6666) {
            bossBar.setColor(BarColor.YELLOW);
        } else {
            bossBar.setColor(BarColor.GREEN);
        }
    }

    public static void setBarProgress(BossBar bossBar, double percent) {
        if (percent <= 0) {
            percent = 0;
        } else if (percent >= 1) {
            percent = 1;
        }
        bossBar.setProgress(percent);
    }

    public static void addBossBar(Player player, List<BossBar> bossBarList) {
        for (BossBar bossBar : bossBarList) {
            bossBar.addPlayer(player);
        }
    }

    public static void removeBossBar(Player player, List<BossBar> bossBarList) {
        for (BossBar bossBar : bossBarList) {
            bossBar.removePlayer(player);
        }
    }
}
