package com.yaohun.enderdragonwars.util;

import com.sk89q.worldedit.EditSession;
import com.sk89q.worldedit.WorldEdit;
import com.sk89q.worldedit.bukkit.BukkitAdapter;
import com.sk89q.worldedit.extent.clipboard.Clipboard;
import com.sk89q.worldedit.extent.clipboard.io.ClipboardFormats;
import com.sk89q.worldedit.math.BlockVector3;
import com.yaohun.enderdragonwars.Main;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.World;

import java.io.File;

public class WEUtil {

    public static void loadSchematics(Location location, String fileName) {
        File path = new File(Main.plugin.getDataFolder(), "schematics");
        if (!path.exists()) {
            path.mkdirs();
        }
        File schematicFile = new File(path, fileName + ".schem");
        if (!schematicFile.exists()) {
            Main.plugin.saveResource("schematics/" + fileName + ".schem", false);
        }
        World world = location.getWorld();
        EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(world));
        Bukkit.getScheduler().runTaskAsynchronously(Main.plugin, () -> {
                    try {
                        Clipboard clipboard = ClipboardFormats.findByFile(schematicFile).load(schematicFile);
                        clipboard.paste(BukkitAdapter.adapt(world), BlockVector3.at(location.getBlockX(), location.getBlockY(), location.getBlockZ()));
                        clipboard.flush();
                    } catch (Exception e) {
                        e.printStackTrace();
                    } finally {
                        editSession.close();
                    }
                }
        );

    }

}
